unit dReportChart_01;

interface

uses
  { System }
  System.SysUtils,
  System.Classes,
  { ReportBuilder }
  ppPrnabl,
  ppClass,
  ppCtrls,
  ppChrt,
  ppParameter,
  ppDesignLayer,
  ppBands,
  ppCache,
  ppComm,
  ppRelatv,
  ppProd,
  ppReport,
  { TeeChart }
  VCLTee.Chart,
  VCLTee.TeEngine,
  { Uniform }
  dBaseReport;

type
  TdmReportChart_01 = class(TdmBaseReport)
    ppTeeChart_SCCLast2Years: TppTeeChart;
  private
  procedure FillChart(AChart: TCustomChart);
  protected
    procedure InitializeReport; override;
  public
    { Public declarations }
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  { System }
  Vcl.Graphics;

{ TdmReportChart_01 }

procedure TdmReportChart_01.FillChart(AChart: TCustomChart);

  function ValueSerie(ANr: Integer; X: Double): Double;
  begin
    Result := 0;
    if (ANr = 1) then
    begin
      Result := X / 10;
    end
    else if (ANr = 2) then
    begin
      Result := Sqrt(X) + 2;
    end
    else if (ANr = 3) then
    begin
      Result := 2 * Sqrt(X) + 1;
    end;
  end;

var
  i: Integer;
  LDate: TDate;
  LSeries1: TChartSeries;
  LSeries2: TChartSeries;
  LSeries3: TChartSeries;
  LStartDate: TDate;
begin
  AChart.Visible := True;
  LSeries1 := AChart.SeriesList.Find('Series1');
  LSeries2 := AChart.SeriesList.Find('Series2');
  LSeries3 := AChart.SeriesList.Find('Series3');
  LSeries1.Clear;
  LSeries2.Clear;
  LSeries3.Clear;
  LStartDate := Trunc(Now);
  for i := 0 to 365 do
  begin
    LDate := LStartDate + i;
    LSeries1.AddXY(LDate, ValueSerie(1, i), DateToStrChartAxis(LDate), clRed);
    LSeries2.AddXY(LDate, ValueSerie(2, i), DateToStrChartAxis(LDate), clGreen);
    LSeries3.AddXY(LDate, ValueSerie(3, i), DateToStrChartAxis(LDate), clBlue);
  end;
  AChart.LeftAxis.Maximum := 50;
  AChart.RightAxis.Maximum := 50;
end;

procedure TdmReportChart_01.InitializeReport;
begin
  FChartName := 'Chart_01';
  FillChart(ppTeeChart_SCCLast2Years.Chart);
end;

end.
