unit dReportChart_02;

interface

uses
  { System }
  System.SysUtils,
  System.Classes,
  { ReportBuilder }
  ppPrnabl,
  ppClass,
  ppCtrls,
  ppChrt,
  ppParameter,
  ppDesignLayer,
  ppBands,
  ppCache,
  ppComm,
  ppRelatv,
  ppProd,
  ppReport,
  { TeeChart }
  VCLTee.Chart,
  VCLTee.TeEngine,
  VCLTee.TeeShape,
  { Uniform }
  dBaseReport;

type
  TdmReportChart_02 = class(TdmBaseReport)
    ppTeeChart_CompareLast2MR: TppTeeChart;
  private
  procedure FillChart(AChart: TCustomChart);
  protected
    procedure InitializeReport; override;
  public
    { Public declarations }
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  { System }
  Vcl.Graphics,
  Winapi.Windows;

{ TdmReportChart_02 }

procedure TdmReportChart_02.FillChart(AChart: TCustomChart);

  function ValueSerie(ANr: Integer; X: Double): Double;
  begin
    Result := 0;
    if (ANr = 1) then
    begin
      Result := X / 10;
    end
    else if (ANr = 2) then
    begin
      Result := Sqrt(X) + 2;
    end
    else if (ANr = 3) then
    begin
      Result := 2 * Sqrt(X) + 1;
    end
    else if (ANr = 4) then
    begin
      Result := Sqrt(2 * X) + 3;
    end;
  end;

const
  CELL_COUNT_BORDER = 250;
var
  i: Integer;
  LCellCount: Integer;
  LCellCountPrev: Integer;
  LItemColor: Cardinal;
  LSeries1: TChartSeries;
  LSeries2: TChartSeries;
  LSeries3: TChartSeries;
  LSeries4: TChartSeries;
  LSeries5: TChartShape;
  LSeries6: TChartShape;
  LSeries7: TChartShape;
begin
  AChart.Visible := True;
  LSeries1 := AChart.SeriesList.Find('Series1');
  LSeries2 := AChart.SeriesList.Find('Series2');
  LSeries3 := AChart.SeriesList.Find('Series3');
  LSeries4 := AChart.SeriesList.Find('Series4');
  LSeries5 := TChartShape(AChart.SeriesList.Find('Series5'));
  LSeries6 := TChartShape(AChart.SeriesList.Find('Series6'));
  LSeries7 := TChartShape(AChart.SeriesList.Find('Series7'));

  LSeries1.Clear;
  LSeries2.Clear;
  LSeries3.Clear;
  LSeries4.Clear;
  LSeries5.Clear;
  LSeries6.Clear;
  LSeries7.Clear;

  LSeries1.SeriesColor := RGB(233,233,233);
  LSeries1.Title := 'Healthy';

  Randomize;
  LCellCountPrev := Random(1000);
  for i := 1 to 100 do
  begin
    LCellCount := Random(1000);
    LItemColor := RGB(233, 233, 233);
    if LCellCount >= CELL_COUNT_BORDER then
    begin
      if LCellCountPrev >= CELL_COUNT_BORDER then
      begin
        LItemColor := RGB(162, 55, 181);
      end
      else
      begin
        LItemColor := RGB(255, 0, 0);
      end
    end
    else
    begin
      if LCellCountPrev >= CELL_COUNT_BORDER then
      begin
        LItemColor := RGB(50, 116, 44);
      end;
    end;
    LSeries1.AddXY(LCellCount, LCellCountPrev, IntToStr(i), LItemColor);
    LCellCountPrev := LCellCount;
  end;

  LSeries5.SeriesColor := RGB(255,0,0);
  LSeries5.Title       := 'New infected';
  LSeries5.X0          := CELL_COUNT_BORDER;
  LSeries5.X1          := AChart.MaxXValue(AChart.BottomAxis);
  LSeries5.Y0          := 0;
  LSeries5.Y1          := CELL_COUNT_BORDER;
  LSeries2.SeriesColor := RGB(255,0,0);
  LSeries2.Title       := 'New infected';

  LSeries6.SeriesColor := RGB(162,55,181);
  LSeries6.Title       := 'Chronical';
  LSeries6.X0          := CELL_COUNT_BORDER;
  LSeries6.X1          := AChart.MaxXValue(AChart.BottomAxis);
  LSeries6.Y0          := CELL_COUNT_BORDER;
  LSeries6.Y1          := AChart.MaxYValue(AChart.LeftAxis);
  LSeries3.SeriesColor := RGB(162,55,181);
  LSeries3.Title       := 'Chronical';

  LSeries7.SeriesColor := RGB(50,116,44);
  LSeries7.Title       := 'Cured';
  LSeries7.X0          := 0;
  LSeries7.X1          := CELL_COUNT_BORDER;
  LSeries7.Y0          := CELL_COUNT_BORDER;
  LSeries7.Y1          := AChart.MaxYValue(AChart.LeftAxis);
  LSeries1.SeriesColor := RGB(50,116,44);
  LSeries1.Title       := 'Cured';

  AChart.LeftAxis.Maximum := 1050;
end;

procedure TdmReportChart_02.InitializeReport;
begin
  FChartName := 'Chart_02';
  FillChart(ppTeeChart_CompareLast2MR.Chart);
end;

end.
