unit dReportChart_03;

interface

uses
  { System }
  System.SysUtils,
  System.Classes,
  { ReportBuilder }
  ppPrnabl,
  ppClass,
  ppCtrls,
  ppChrt,
  ppParameter,
  ppDesignLayer,
  ppBands,
  ppCache,
  ppComm,
  ppRelatv,
  ppProd,
  ppReport,
  { TeeChart }
  VCLTee.Chart,
  VCLTee.Series,
  VCLTee.TeEngine,
  { Uniform }
  dBaseReport;

type
  TdmReportChart_03 = class(TdmBaseReport)
    ppTeeChart_PerMilkRecording: TppTeeChart;
  private
  procedure FillChart(AChart: TCustomChart);
  protected
    procedure InitializeReport; override;
  public
    { Public declarations }
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  { System }
  Vcl.Graphics,
  Winapi.Windows;

{ TdmReportChart_03 }

procedure TdmReportChart_03.FillChart(AChart: TCustomChart);

  function Value(AMax: Integer): Integer;
  begin
    Result := 1 + Trunc(Random(AMax));
  end;

var
  LChartLabel: string;
  LDate: TDate;
  LEndDate: TDate;
  LSeries1: TBarSeries;
  LSeries2: TBarSeries;
  LSeries3: TBarSeries;
  LSeries4: TBarSeries;
  LStartDate: TDate;
  LValue1: Integer;
  LValue2: Integer;
  LValue3: Integer;
  LValue4: Integer;
begin
  AChart.Visible := True;
  LSeries1 := TBarSeries(AChart.SeriesList.Find('srSCCNewInfected'));
  LSeries2 := TBarSeries(AChart.SeriesList.Find('srSCCChronical'));
  LSeries3 := TBarSeries(AChart.SeriesList.Find('srSCCCured'));
  LSeries4 := TBarSeries(AChart.SeriesList.Find('srSCCHealthy'));

  LSeries1.Clear;
  LSeries2.Clear;
  LSeries3.Clear;
  LSeries4.Clear;
  LSeries1.Color := RGB(255, 0, 0);
  LSeries2.Color := RGB(162, 55, 181);
  LSeries3.Color := RGB(50, 116, 44);
  LSeries4.Color := RGB(233, 233, 233);

  LStartDate := Trunc(Now);
  LEndDate := LStartDate + 365;
  LDate := LStartDate;
  while (LDate < LEndDate) do
  begin
    LChartLabel := DateToStrChartAxis(LDate);
    LValue1 := Value(10);
    LValue2 := Value(25);
    LValue3 := Value(20);
    LValue4 := 100 - LValue1 - LValue2 - LValue3;
    LSeries1.AddBar(LValue1, '', LSeries1.Color);
    LSeries2.AddBar(LValue2, '', LSeries2.Color);
    LSeries3.AddBar(LValue3, '', LSeries3.Color);
    LSeries4.AddBar(LValue4, LChartLabel, LSeries4.Color);
    LDate := LDate + 14;
  end;
end;

procedure TdmReportChart_03.InitializeReport;
begin
  FChartName := 'Chart_03';
  FillChart(ppTeeChart_PerMilkRecording.Chart);
end;

end.
