unit dReportChart_04;

interface

uses
  { System }
  System.Classes,
  { ReportBuilder }
  ppParameter,
  ppDesignLayer,
  ppBands,
  ppPrnabl,
  ppClass,
  ppCtrls,
  ppCache,
  ppComm,
  ppRelatv,
  ppProd,
  ppReport,
  ppChrt,
  { TeeChart }
  VCLTee.Chart,
  VCLTee.Series,
  { Uniform }
  dBaseReport;

type
  TdmReportChart_04 = class(TdmBaseReport)
    ppTeeChart_SCCLastMR: TppTeeChart;
  private
    procedure FillChart(AChart: TCustomChart);
  protected
    procedure InitializeReport; override;
  public
    { Public declarations }
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  { System }
  Winapi.Windows;

{ TdmReportChart_04 }

procedure TdmReportChart_04.FillChart(AChart: TCustomChart);

  function Value(AMax: Integer): Integer;
  begin
    Result := 1 + Trunc(Random(AMax));
  end;

var
  LSeries: TPieSeries;
  LValue0: Integer;
  LValue1: Integer;
  LValue2: Integer;
  LValue3: Integer;
  LValue4: Integer;
  LValue5: Integer;
begin
  AChart.Visible := True;
  LSeries := TPieSeries(AChart.SeriesList.Find('Series1'));

  LSeries.Clear;
  LValue1 := Value(20);
  LValue2 := Value(20);
  LValue3 := Value(20);
  LValue4 := Value(20);
  LValue5 := Value(20);
  LValue0 := Value(100) + Value(100);
  LSeries.AddPie(LValue5, 'Cows: > 500.000 cells', RGB(255, 0, 0));
  LSeries.AddPie(LValue4, 'Cows: 400.000 - 500.000 cells', RGB(241, 141, 5));
  LSeries.AddPie(LValue3, 'Cows: 300.000 - 400.000 cells', RGB(255, 194, 14));
  LSeries.AddPie(LValue2, 'Cows: 200.000 - 300.000 cells', RGB(162, 55, 181));
  LSeries.AddPie(LValue1, 'Cows: 100.000 - 200.000 cells', RGB(17, 63, 140));
  LSeries.AddPie(LValue0, 'Cows: < 100.000 cells', RGB(50, 116, 44));
end;

procedure TdmReportChart_04.InitializeReport;
begin
  FChartName := 'Chart_04';
  FillChart(ppTeeChart_SCCLastMR.Chart);
end;

end.
