unit dReportChart_05;

interface

uses
  { System }
  System.Classes,
  { ReportBuilder }
  ppParameter,
  ppDesignLayer,
  ppBands,
  ppPrnabl,
  ppClass,
  ppCtrls,
  ppCache,
  ppComm,
  ppRelatv,
  ppProd,
  ppReport,
  ppChrt,
  { TeeChart }
  VCLTee.Chart,
  { Uniform }
  dBaseReport;

type
  TdmReportChart_05 = class(TdmBaseReport)
    chrtDIMTrend: TppTeeChart;
  private
    procedure FillChart(AChart: TCustomChart);
  protected
    procedure InitializeReport; override;
  public
    { Public declarations }
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  { System }
  System.Math,
  VCLTee.Series;

{ TdmReportChart_05 }

procedure TdmReportChart_05.FillChart(AChart: TCustomChart);

  function RandomTrendValue: Double;
  begin
    Result := 3 * Random - 1.5;
  end;

const
  MAX_X_VALUE = 10000;
  MAX_Y_VALUE = 100;
  MIN_Y_VALUE = 0;
var
  i: Integer;
  LsrDIMTrend: TLineSeries;
  LsrDIMTrend100: TLineSeries;
  LsrDIMTrend75: TLineSeries;
  LStartValue: Double;
  LValue: Double;
begin
  AChart.Visible := True;

  LsrDIMTrend := AChart.SeriesList.Find('lsrDIMTrend') as TLineSeries;
  LsrDIMTrend100 := AChart.SeriesList.Find('lsrDIMTrend100') as TLineSeries;
  LsrDIMTrend75 := AChart.SeriesList.Find('lsrDIMTrend75') as TLineSeries;
  LsrDIMTrend.Clear;
  LsrDIMTrend100.Clear;
  LsrDIMTrend75.Clear;
  LStartValue := 50;
  LValue := LStartValue;

  for i := 0 to MAX_X_VALUE do
  begin
    LValue := Min(Max(MIN_Y_VALUE, LValue + RandomTrendValue), MAX_Y_VALUE);
    LsrDIMTrend.AddXY(i, LValue);
  end;
  AChart.BottomAxis.SetMinMax(0, chrtDIMTrend.Chart.MaxXValue(AChart.BottomAxis));
  AChart.RightAxis.SetMinMax(Min(30, chrtDIMTrend.Chart.MinYValue(AChart.RightAxis) - 10), 105);

  LsrDIMTrend100.AddXY(AChart.MinXValue(AChart.BottomAxis), LStartValue);
  LsrDIMTrend100.AddXY(AChart.MaxXValue(AChart.BottomAxis), MAX_Y_VALUE);
  LsrDIMTrend75.AddXY(AChart.MinXValue(AChart.BottomAxis), LStartValue);
  LsrDIMTrend75.AddXY(AChart.MaxXValue(AChart.BottomAxis), 3 * MAX_Y_VALUE / 4);
end;

procedure TdmReportChart_05.InitializeReport;
begin
  FChartName := 'Chart_05';
  FillChart(chrtDIMTrend.Chart);
end;

end.
