unit dReportChart_08;

interface

uses
  { RTL / VCL }
  System.Classes,
  { ReportBuilder }
  ppBands,
  ppCtrls,
  ppPrnabl,
  ppClass,
  ppCache,
  ppProd,
  ppReport,
  ppRelatv,
  ppChrt,
  ppParameter,
  ppDesignLayer,
  ppStrtch,
  ppSubRpt,
  ppComm,
  { TeeChart }
  VclTee.Chart,
//  VclTee.TeeTools,
  { UNIFORM }
  dBaseReport;

type
  TdmInseminationsChartReport_08 = class(TdmBaseReport)
    srQSum: TppSubReport;
    ppChildReport1: TppChildReport;
    ppTitleBand1: TppTitleBand;
    ppSummaryBand1: TppSummaryBand;
    chrtQSum: TppTeeChart;
    srDIMTrend: TppSubReport;
    ppChildReport2: TppChildReport;
    ppTitleBand2: TppTitleBand;
    ppDetailBand2: TppDetailBand;
    ppSummaryBand2: TppSummaryBand;
    chrtDIMTrend: TppTeeChart;
    srFirstIns: TppSubReport;
    ppChildReport5: TppChildReport;
    ppTitleBand5: TppTitleBand;
    ppDetailBand5: TppDetailBand;
    ppSummaryBand5: TppSummaryBand;
    chrtFirstIns: TppTeeChart;
    srPregnancy: TppSubReport;
    ppChildReport6: TppChildReport;
    ppTitleBand6: TppTitleBand;
    ppDetailBand6: TppDetailBand;
    ppSummaryBand6: TppSummaryBand;
    chrtPregnancy: TppTeeChart;
    ppDesignLayers3: TppDesignLayers;
    ppDesignLayer3: TppDesignLayer;
    ppDesignLayers4: TppDesignLayers;
    ppDesignLayer4: TppDesignLayer;
    ppDesignLayers7: TppDesignLayers;
    ppDesignLayer7: TppDesignLayer;
    ppDesignLayers8: TppDesignLayers;
    ppDesignLayer8: TppDesignLayer;
  private
    procedure FillChart(AChart: TCustomChart);
  protected
  public
    procedure InitializeReport; override;
  end;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses
  System.Math,
  { TeeChart }
  VclTee.Series;

{$R *.dfm}

{ TdmInseminationsChartReport_08 }

procedure TdmInseminationsChartReport_08.FillChart(AChart: TCustomChart);

  function RandomTrendValue: Double;
  begin
    Result := 3 * Random - 1.3;
  end;

const
  MAX_X_VALUE = 100;
  MAX_Y_VALUE = 100;
  MIN_Y_VALUE = 0;
var
  i: Integer;
  LsrDIMTrend: TLineSeries;
  LsrDIMTrend100: TLineSeries;
  LsrDIMTrend75: TLineSeries;
  LStartValue: Double;
  LValue: Double;
begin
  AChart.Visible := True;

  LsrDIMTrend := AChart.SeriesList.Find('lsrDIMTrend') as TLineSeries;
  LsrDIMTrend100 := AChart.SeriesList.Find('lsrDIMTrend100') as TLineSeries;
  LsrDIMTrend75 := AChart.SeriesList.Find('lsrDIMTrend75') as TLineSeries;
  LsrDIMTrend.Clear;
  LsrDIMTrend100.Clear;
  LsrDIMTrend75.Clear;
  LStartValue := 50;
  LValue := LStartValue;

  for i := 0 to MAX_X_VALUE do
  begin
    LValue := Min(Max(MIN_Y_VALUE, LValue + RandomTrendValue), MAX_Y_VALUE);
    LsrDIMTrend.AddXY(i, LValue);
  end;
  AChart.BottomAxis.SetMinMax(0, chrtDIMTrend.Chart.MaxXValue(AChart.BottomAxis));
  AChart.RightAxis.SetMinMax(Min(30, chrtDIMTrend.Chart.MinYValue(AChart.RightAxis) - 10), 105);

  LsrDIMTrend100.AddXY(AChart.MinXValue(AChart.BottomAxis), LStartValue);
  LsrDIMTrend100.AddXY(AChart.MaxXValue(AChart.BottomAxis), MAX_Y_VALUE);
  LsrDIMTrend75.AddXY(AChart.MinXValue(AChart.BottomAxis), LStartValue);
  LsrDIMTrend75.AddXY(AChart.MaxXValue(AChart.BottomAxis), 3 * MAX_Y_VALUE / 4);
end;

procedure TdmInseminationsChartReport_08.InitializeReport;
begin
  inherited;
  srDIMTrend.Visible := True;
  srQSum.Visible := False;
  srFirstIns.Visible := False;
  srPregnancy.Visible := False;

  FillChart(chrtDIMTrend.Chart);
end;

end.
