unit uSettings;

interface

type
  TSettings = class(TObject)
  private
    FChart: Integer;
    FDoLoadLogo: Boolean;
    FDoLogReports: Boolean;
    FDoMergeReports: Boolean;
    FDoPrintDirectlyToPdf: Boolean;
    FLogFolder: string;
    FNumberOfReports: Integer;
    FNumberOfThreads: Integer;
    FPause: Integer;
  public
    property Chart: Integer read FChart write FChart;
    property DoLoadLogo: Boolean read FDoLoadLogo write FDoLoadLogo;
    property DoLogReports: Boolean read FDoLogReports write FDoLogReports;
    property DoMergeReports: Boolean read FDoMergeReports write FDoMergeReports;
    property DoPrintDirectlyToPdf: Boolean read FDoPrintDirectlyToPdf write FDoPrintDirectlyToPdf;
    property LogFolder: string read FLogFolder write FLogFolder;
    property NumberOfReports: Integer read FNumberOfReports write FNumberOfReports;
    property NumberOfThreads: Integer read FNumberOfThreads write FNumberOfThreads;
    property Pause: Integer read FPause write FPause;
    function WriteSettings: string;
  end;

implementation

uses
  { System }
  System.SysUtils;

{ TSettings }

function TSettings.WriteSettings: string;
begin
  Result := sLineBreak + '******************** SETTINGS ******************** SETTINGS ********************';
  Result := Result + sLineBreak + '    NumberOfThreads: ' + IntToStr(FNumberOfThreads);
  Result := Result + sLineBreak + '    NumberOfReports: ' + IntToStr(FNumberOfReports);
  if (FChart <= 0) then
    Result := Result + sLineBreak + '    Chart: Random'
  else
    Result := Result + sLineBreak + '    Chart: ' + IntToStr(FChart);
  Result := Result + sLineBreak + '    DoPrintDirectlyToPdf: ' + BoolToStr(FDoPrintDirectlyToPdf, True);
  Result := Result + sLineBreak + '    DoLoadLogo: ' + BoolToStr(FDoLoadLogo, True);
  Result := Result + sLineBreak + '    DoLogReports: ' + BoolToStr(FDoLogReports, True);
  if not FDoPrintDirectlyToPdf then
    Result := Result + sLineBreak + '    DoMergeReports: ' + BoolToStr(FDoMergeReports, True);
  if FDoLogReports then
    Result := Result + sLineBreak + '    LogFolder: ' + FLogFolder;
  if (FPause > 0) then
    Result := Result + sLineBreak + '    Pause: ' + IntToStr(FPause);
  Result := Result + sLineBreak + '******************** SETTINGS ******************** SETTINGS ********************';
end;

end.
