unit uWorker;

interface

uses
  { Uniform }
  uGlobalWorker;

type
  TChartRandom_Worker = class(TGlobalWorker)
  strict protected
    function ProcessData: Boolean; override;
  end;

implementation

uses
  { System }
  System.Classes,
  System.Math,
  System.SysUtils,
  { Uniform }
  uLogManager,
  dBaseReport,
  dReportChart_01,
  dReportChart_02,
  dReportChart_03,
  dReportChart_04,
  dReportChart_05,
  dReportChart_06,
  {$IFDEF BUILDTCHARTPRO}
    dReportChart_07,
  {$ENDIF}
  dReportChart_08,
  dReportText_01;

{ TChartRandom_Worker }

function TChartRandom_Worker.ProcessData: Boolean;
const
  NUMBER_OF_CHARTS = 8;
var
  LChartNumber: Integer;
  LReport: TdmBaseReport;
  LStream: TMemoryStream;
begin
  Result := False;
  LChartNumber := FSettings.Chart;
  if (LChartNumber <= 0) or (LChartNumber > NUMBER_OF_CHARTS) then
    LChartNumber := Min(NUMBER_OF_CHARTS, 1 + Random(NUMBER_OF_CHARTS));
  LReport := nil;
  if (LChartNumber = 1) then
    LReport := TdmReportChart_01.Create(nil)
  else if (LChartNumber = 2) then
    LReport := TdmReportChart_02.Create(nil)
  else if (LChartNumber = 3) then
    LReport := TdmReportChart_03.Create(nil)
  else if (LChartNumber = 4) then
    LReport := TdmReportChart_04.Create(nil)
  else if (LChartNumber = 5) then
    LReport := TdmReportChart_05.Create(nil)
  else if (LChartNumber = 6) then
    LReport := TdmReportChart_06.Create(nil)
  {$IFDEF BUILDTCHARTPRO}
    else if (LChartNumber = 7) then
      LReport := TdmInseminationsChartReport_07.Create(nil)
  {$ENDIF}
  else if (LChartNumber = 8) then
    LReport := TdmInseminationsChartReport_08.Create(nil)
  else if (LChartNumber = 9) then
    LReport := TdmReportText_01.Create(nil);

  if Assigned(LReport) then
  begin
    try
      LReport.Settings := FSettings;
      LStream := LReport.GenerateReport(FCurrentNumber);
      Result := True;
    finally
      LReport.Free;
    end;
    if Assigned(LStream) then
      ProcessResult(LChartNumber, LStream);
  end
  else
  begin
    LogManager.LogMessageInfo(Format('Report not supported! %d', [FCurrentNumber]));
  end;
end;

end.
